﻿@using Services;
@using WebCalc.Constants;
@inject ConvertService convertService

<div>
    <EditForm Model="@DummyModel">
        <div class="form-group">
            <h6>BMI = Weight in kg / Height^2 in meter</h6>
            <h6>Only applicable if your age is between 20 - 80 and not pregnant</h6>
        </div>
        <div class="form-group">
            <table class="table table-sm">
                <tbody>
                    <tr>
                        <td>Height</td>
                        <td>
                            <input class="form-control form-control-sm mr-sm-2" @bind-Value="HeightValue" @bind-Value:event="oninput" maxlength="8" />
                        </td>
                        <td>
                            <InputSelect class="form-control form-control-sm" @bind-Value="HeightTypeValue">
                                @foreach (var item in Enum.GetValues(typeof(LengthType)))
                                {
                                    <option value="@item">@item</option>
                                }
                            </InputSelect>
                        </td>
                    </tr>
                    <tr>
                        <td>Weight</td>
                        <td>
                            <input class="form-control form-control-sm mr-sm-2" @bind-Value="WeightValue" @bind-Value:event="oninput" maxlength="6" />
                        </td>
                        <td>
                            <InputSelect class="form-control form-control-sm" @bind-Value="WeightTypeValue">
                                @foreach (var item in Enum.GetValues(typeof(MassType)))
                                {
                                    <option value="@item">@item</option>
                                }
                            </InputSelect>
                        </td>
                    </tr>
                    <tr>
                        <td></td>
                        <td>
                            <div class="form-group">
                                <div class="form-check">
                                    <label class="form-check-label">
                                        <input type="checkbox" class="form-check-input" @bind="IsAsian"> Is Asian
                                    </label>
                                </div>
                            </div>
                        </td>
                        <td></td>
                    </tr>
                </tbody>
            </table>
        </div>
        <div class="form-group">
            <table class="table table-bordered table-sm">
                <tbody>
                    <tr>
                        <td>BMI Value</td>
                        <td>@BMIValue</td>
                    </tr>
                    <tr>
                        <td>Under weight if below</td>
                        <td>@BMIUnderWeight</td>
                    </tr>
                    <tr>
                        <td>Normal weight between</td>
                        <td>@BMINormalWeight</td>
                    </tr>
                    <tr>
                        <td>Over weight between</td>
                        <td>@BMIOverWeight</td>
                    </tr>
                    <tr>
                        <td>Obese if above</td>
                        <td>@BMIObeseWeight</td>
                    </tr>
                </tbody>
            </table>
        </div>
    </EditForm>
</div>

@code {

    private string DummyModel { get; set; } = string.Empty;

    private const double BMIValue_NormalMin = 18.5;
    private const double BMIValue_NormalMax_Asian = 23;
    private const double BMIValue_NormalMax_NonAsian = 25;
    private const double BMIValue_OverMax = 30;

    private double HeightValue { get; set; } = 0;
    private double WeightValue { get; set; } = 0;
    private bool IsAsian { get; set; } = false;

    private LengthType HeightTypeValue { get; set; } = LengthType.Centimeter;
    private MassType WeightTypeValue { get; set; } = MassType.Kilogram;

    private string BMIValue { get; set; }
    private string BMIUnderWeight { get; set; }
    private string BMINormalWeight { get; set; }
    private string BMIOverWeight { get; set; }
    private string BMIObeseWeight { get; set; }

    private double CalculateBMIValue(double heightInMeter, double weightInKg)
    {
        double bmiValue;
        bmiValue = weightInKg / Math.Pow(heightInMeter, 2);
        return bmiValue;
    }

    private double CalculateWeightFromBMI(double heightInMeter, double bmiValue)
    {
        double weightInKg;
        weightInKg = bmiValue * Math.Pow(heightInMeter, 2);
        return weightInKg;
    }

    private string GetBMIValueString(double heightInMeter, double weightInKg)
    {
        double toWeightInKg, toWeightValue;
        double bmiValue = Math.Round(CalculateBMIValue(heightInMeter, weightInKg), 2);
        string suffix;

        if (bmiValue < BMIValue_NormalMin) suffix = "Under weight";
        else if (IsAsian && bmiValue >= BMIValue_NormalMin && bmiValue < BMIValue_NormalMax_Asian) suffix = "Normal weight";
        else if (!IsAsian && bmiValue >= BMIValue_NormalMin && bmiValue < BMIValue_NormalMax_NonAsian) suffix = "Normal weight";
        else if (IsAsian && bmiValue >= BMIValue_NormalMax_Asian && bmiValue < BMIValue_OverMax) suffix = "Over weight";
        else if (!IsAsian && bmiValue >= BMIValue_NormalMax_NonAsian && bmiValue < BMIValue_OverMax) suffix = "Over weight";
        else if (bmiValue >= BMIValue_OverMax) suffix = "Obese";
        else throw new NotImplementedException();

        double diffBMIValue = 0;
        if (bmiValue < BMIValue_NormalMin)
            diffBMIValue = BMIValue_NormalMin;
        else if ((IsAsian && bmiValue >= BMIValue_NormalMax_Asian) || (!IsAsian && bmiValue >= BMIValue_NormalMax_NonAsian))
            diffBMIValue = IsAsian ? BMIValue_NormalMax_Asian : BMIValue_NormalMax_NonAsian;
        if (diffBMIValue > 0)
        {
            toWeightInKg = weightInKg - CalculateWeightFromBMI(heightInMeter, diffBMIValue);
            toWeightValue = convertService.ConvertMass(MassType.Kilogram, WeightTypeValue, toWeightInKg);
            suffix += " by " + Math.Round(toWeightValue) + " " + convertService.GetMassAbbreviation(WeightTypeValue);
        }

        return bmiValue.ToString() + " (" + suffix + ")";
    }

    private string GetWeightRangeString(double heightInMeter, double bmiValue)
    {
        double weightInKg = CalculateWeightFromBMI(heightInMeter, bmiValue);
        double weightValue = convertService.ConvertMass(MassType.Kilogram, WeightTypeValue, weightInKg);
        return Math.Round(weightValue) + " " + convertService.GetMassAbbreviation(WeightTypeValue);
    }

    protected override bool ShouldRender()
    {
        RefreshValues();
        return base.ShouldRender();
    }

    private void RefreshValues()
    {
        double heightInMeter = convertService.ConvertLength(HeightTypeValue, LengthType.Meter, HeightValue);
        double weightInKg = convertService.ConvertMass(WeightTypeValue, MassType.Kilogram, WeightValue);
        if (heightInMeter > 1 && heightInMeter < 4)
        {
            BMIValue = GetBMIValueString(heightInMeter, weightInKg);
            BMIUnderWeight = GetWeightRangeString(heightInMeter, BMIValue_NormalMin);
            BMIObeseWeight = GetWeightRangeString(heightInMeter, BMIValue_OverMax);
            if (IsAsian)
            {
                BMINormalWeight = BMIUnderWeight + " - " + GetWeightRangeString(heightInMeter, BMIValue_NormalMax_Asian);
                BMIOverWeight = GetWeightRangeString(heightInMeter, BMIValue_NormalMax_Asian) + " - " + BMIObeseWeight;
            }
            else
            {
                BMINormalWeight = BMIUnderWeight + " - " + GetWeightRangeString(heightInMeter, BMIValue_NormalMax_NonAsian);
                BMIOverWeight = GetWeightRangeString(heightInMeter, BMIValue_NormalMax_NonAsian) + " - " + BMIObeseWeight;
            }
        }
        else
        {
            BMIValue = "-";
            BMIUnderWeight = "-";
            BMINormalWeight = "-";
            BMIOverWeight = "-";
            BMIObeseWeight = "-";
        }
    }
}
